// packageA//pages/myGift/myGift.js
const app = getApp();
let self = null;
var os = app.globalData.setting;

Page({

  /**
   * 页面的初始数据
   */
  data: {
		tabArr: ['抽奖列表', '历史抽奖'],
		currentIndex: 0,
		
		list: null,
		isLoading: false, // 检测是否已经发送请求,防止重复发送请求
		noMore: false, // 检测是否有更多数据,true为没有更多数据,false为还有数据
		pageNum: 1, // 当前页数
  },
	
	clickTab(e) {
		let index = e.target.dataset.index;
		let url = '/api/weshop/marketing/marketingLuckForm/page';
		let data = {
			store_id: app.globalData.setting.stoid,
			user_id: app.globalData.userInfo.user_id,
		};
		
		this.setData({
			list: null,
			pageNum: 1,
			noMore: false,
			currentIndex: index,
		});
		
		if(index == 0) {
			data.is_end = 0;
			data.timetype = 1;
		} else if(index == 1) {
			data.is_end = 1;
		};
		
		this.getData(true, url, data).then(function() {
			self.setData({
				currentData: data,
			});
		});		
	},

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
		self = this;

		app.isLogin().then(function(data) {//进入页面前已经授权登录成功
			self.setData({
				userInfo: data,
			});
		});
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
      getApp().check_can_share();

		if(app.globalData.userInfo) {
			if(!this.data.isLogin) {
				this.setData({
					userInfo: app.globalData.userInfo,
					imghost: app.globalData.setting.imghost,
					isLogin: true,
				});


				let url = '/api/weshop/marketing/marketingLuckForm/page';
				let data = {
					store_id: app.globalData.setting.stoid,
					user_id: app.globalData.userInfo.user_id,
					is_end: 0,
					timetype:1
				};
				
				this.setData({
					list: null,
					pageNum: 1,
					noMore: false,
				});

				this.getData(true, url, data).then(function() {
					self.setData({
						currentData: data,
					});
				});
				
				// 获取广告
				app.request.promiseGet("/api/weshop/ad/page", {
				  data: {
				    pid: 1201,
				    store_id: app.globalData.setting.stoid, 
				    enabled: 1
				  }
				}).then(res => {
					if(res.data.code==0 && res.data.data && res.data.data.pageData && res.data.data.pageData.length>0){
						var a = res.data.data.pageData;
						var narr=[];
						for(var i in a){
							var tt = {
							  'ad_code': os.imghost + a[i].ad_code,
							  'media_link': '',
							  'ad_weapplink':a[i].ad_weapplink
							};
							narr.push(tt);
						}

						self.setData({
							ad_data: narr,
						});				
					}					 			
				})
				
				
			};
		};
		
		
		
		
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
		let data = this.data.currentData;
		console.log('触底！', data);
		this.scrollToLower('/api/weshop/marketing/marketingLuckForm/page', data);
  },

  /**
   * 用户点击右上角分享
   */
   onShareAppMessage: function () {   	  getApp().globalData.no_clear=1

  },
	
	/**
	 * 请求数据
	 */
	getData: function(isInit, url, data) {
		let p = app.request.promiseGet(url, {
			data: data,
			isShowLoading: true,
		})
		.then(function(res) {
			if(res.data.code == 0) {
				
				self.setData({
					isLoading: false
				});
				
				if(isInit) {// 第一次加载
					self.setData({
						list: res.data.data
					});
				} else {
					self.setData({
						'list.pageData': self.data.list.pageData.concat(res.data.data.pageData)
					});
				};
				
				if((res.data.data.pageData.length == 0) || (res.data.data.pageSize * res.data.data.page >= res.data.data.total)) {
					self.setData({
						noMore: true
					});
				};
				
			} else {
				self.setData({
					'list.pageData': []
				});
			};
			
		});

		return p;
	},
	
	
	/**
	 * 上拉加载
	 */
	scrollToLower(url, requestData) {
		// 数据总量
		let total = this.data.list.total;
		// 单页最大数据量
		let pageSize = this.data.list.pageSize;
		// 如果数据总量不为0且小于或等于单页最大数据量，说明数据已全部加载，显示‘没有更多了’
		if((total != 0)&&(total <= pageSize)) {
			this.setData({
				noMore: true
			});
		};
		
		if(!this.data.isLoading && !this.data.noMore) {
			this.setData({
				isLoading: true,
				pageNum: this.data.pageNum + 1
			});
			requestData.page = this.data.pageNum;
			this.getData(false, url, requestData);
		};
	},
	
	/**
	 * 点击跳转
	 */
	goto(e) {
		// let url = '';
		// if(e.target.dataset.url) {
		// 	url = e.target.dataset.url;
		// } else {
		// 	url = e.currentTarget.dataset.url;
		// }
		let id = e.currentTarget.dataset.id;
		let title = e.currentTarget.dataset.title;
		let url = `/packageB/pages/luckactivity/luckinfo/luckinfo?id=${id}&title=${title}`;
		app.goto(url);
	},



})